<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [Analyzer](#analyzer)
    -   [digit](#digit)
    -   [letter](#letter)
    -   [MODE_INVALID](#mode_invalid)
    -   [MODE_VALUE](#mode_value)
    -   [MODE_UNIT](#mode_unit)
    -   [analyze](#analyze)
    -   [complete](#complete)
    -   [normalize](#normalize)
    -   [group](#group)
-   [Pair](#pair)
    -   [constructor](#constructor)
-   [Converter](#converter)
    -   [toMilliseconds](#tomilliseconds)
-   [toms](#toms)
-   [Parser](#parser)
    -   [digit](#digit-1)
    -   [letter](#letter-1)
    -   [delimiter](#delimiter)
    -   [split](#split)
-   [Types](#types)
    -   [HOUR](#hour)
    -   [MINUTE](#minute)
    -   [SECOND](#second)
    -   [MILLISECOND](#millisecond)
    -   [aliases](#aliases)
    -   [validate](#validate)
    -   [greater](#greater)
    -   [lesser](#lesser)

## Analyzer

Analyzer

Analyzes parsed array and generates pairs array

### digit

digit

**Parameters**

-   `digit` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for digit

### letter

letter

**Parameters**

-   `leter` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for leter

### MODE_INVALID

Invalid mode

**Parameters**

-   `MODE_INVALID` **int** invalid mode

### MODE_VALUE

Invalid value

**Parameters**

-   `MODE_VALUE` **int** value mode

### MODE_UNIT

Invalid unit

**Parameters**

-   `MODE_UNIT` **int** unit mode

### analyze

Analyze parsed array

**Parameters**

-   `array` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)>** parsed array

Returns **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Pair](#pair)>** array analyzed array

### complete

Complete parsed array

Tries to complete left and right missing units or values

**Parameters**

-   `array` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)>** parsed array

Returns **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Pair](#pair)>** array analyzed array

### normalize

Normalizes parsed array

Removes missing or invalid value unit couples

**Parameters**

-   `array` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)>** parsed array

Returns **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Pair](#pair)>** array analyzed array

### group

Groups parsed array

Groups value units into pairs

**Parameters**

-   `array` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)>** parsed array

Returns **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Pair](#pair)>** array analyzed array

## Pair

Pair

Collection of value and unit

**Parameters**

-   `value` **int** value of the pair
-   `unit` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** unit of the pair

### constructor

Pair constructor

**Parameters**

-   `value` **int** value of the pair
-   `unit` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** unit of the pair

## Converter

Converter

Converts analyzed array to int

### toMilliseconds

Converts analyzed array to milliseconds

**Parameters**

-   `array` **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[Pair](#pair)>** analyzed array

Returns **int** millisedonds milliseconds

## toms

Converts analyzed string to milliseconds

**Parameters**

-   `string` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** string to analyze

Returns **int** millisedonds milliseconds

## Parser

Parser

Parses string into array of meaningful values.
Usually it's value, unit, value, unit, but might be
only value, value or unit, unit or completely mixed

### digit

digit

**Parameters**

-   `digit` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for digit

### letter

letter

**Parameters**

-   `leter` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for leter

### delimiter

delimiter

**Parameters**

-   `delimiter` **[RegExp](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp)** regular expression for delimiter

### split

Split string into parts

**Parameters**

-   `string` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** string to split

Returns **[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)>** array value unit parts

## Types

Types

Supported units.

### HOUR

Hour

**Parameters**

-   `HOUR` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** predefined hour

### MINUTE

Minute

**Parameters**

-   `MINUTE` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** predefined minute

### SECOND

SECOND

**Parameters**

-   `SECOND` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** predefined second

### MILLISECOND

MILLISECOND

**Parameters**

-   `MILLISECOND` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** predefined millisecond

### aliases

Aliases

**Parameters**

-   `aliases` **[Object](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object)&lt;[Array](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array)&lt;[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)>>** unit aliases

### validate

Validate unit

**Parameters**

-   `symbol` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** symbol to validate

Returns **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** symbol validated symbol

### greater

Gets greater unit

**Parameters**

-   `symbol` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** symbol to use as a base

Returns **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** symbol greater unit

### lesser

Gets lesser unit

**Parameters**

-   `symbol` **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** symbol to use as a base

Returns **[string](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String)** symbol lesser unit
