'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Types = require('../types/Types');

var _Types2 = _interopRequireDefault(_Types);

var _Pair = require('../analyzer/Pair');

var _Pair2 = _interopRequireDefault(_Pair);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Converter
 *
 * Converts analyzed array to int
 *
 * @static
 * @internal
 */
var Converter = function () {
  function Converter() {
    _classCallCheck(this, Converter);
  }

  _createClass(Converter, null, [{
    key: 'toMilliseconds',

    /**
     * Converts analyzed array to milliseconds
     *
     * @param {Array<Pair>} array analyzed array
     * @return {int} millisedonds milliseconds
     * @static
     */
    value: function toMilliseconds(array) {
      var sum = 0;
      var pair = void 0;
      var i = void 0;
      var length = array.length;

      for (i = 0; i < length; ++i) {
        pair = array[i];
        if (pair.unit === _Types2.default.MILLISECOND) {
          sum += pair.value;
        } else if (pair.unit === _Types2.default.SECOND) {
          sum += pair.value * 1000;
        } else if (pair.unit === _Types2.default.MINUTE) {
          sum += pair.value * 1000 * 60;
        } else if (pair.unit === _Types2.default.HOUR) {
          sum += pair.value * 1000 * 60 * 60;
        }
      }

      return sum;
    }
  }]);

  return Converter;
}();

exports.default = Converter;