'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Parser
 *
 * Parses string into array of meaningful values.
 * Usually it's value, unit, value, unit, but might be
 * only value, value or unit, unit or completely mixed
 *
 * @static
 * @internal
 */
var Parser = function () {
  function Parser() {
    _classCallCheck(this, Parser);
  }

  _createClass(Parser, null, [{
    key: 'split',


    /**
     * Split string into parts
     *
     * @param {string} string string to split
     * @return {Array<string>} array value unit parts
     * @static
     */


    /**
     * letter
     *
     * @param {RegExp} leter regular expression for leter
     * @static
     */
    value: function split(string) {
      var length = string.length;

      var parts = [];
      var i = void 0;
      var current = '';
      var symbol = void 0;
      var pushed = void 0;

      for (i = 0; i < length; ++i) {
        symbol = string[i];

        if (Parser.delimiter.test(symbol)) {
          pushed = Parser._push(symbol, current, parts);
          symbol = pushed.symbol;current = pushed.current;parts = pushed.parts;
        } else if (current !== '') {
          if (Parser.digit.test(current[0]) && Parser.digit.test(symbol) || Parser.letter.test(current[0]) && Parser.letter.test(symbol)) {
            current += symbol;
          } else {
            pushed = Parser._push(symbol, current, parts);
            symbol = pushed.symbol;current = pushed.current;parts = pushed.parts;
          }
        } else {
          current += symbol;
        }
      }

      pushed = Parser._push(symbol, current, parts);
      symbol = pushed.symbol;current = pushed.current;parts = pushed.parts;

      return parts;
    }

    /**
     * Pushes current symbol to the parts
     *
     * @param {string} symbol current symbol
     * @param {string} current current part item
     * @param {Array<string>} parts parts of value units
     * @return {Object} object all the parameters
     * @static
     * @private
     */


    /**
     * delimiter
     *
     * @param {RegExp} delimiter regular expression for delimiter
     * @static
     */

    /**
     * digit
     *
     * @param {RegExp} digit regular expression for digit
     * @static
     */

  }, {
    key: '_push',
    value: function _push(symbol, current, parts) {
      if (current !== '') {
        parts.push(current);
        current = '';
      }
      if (symbol && !Parser.delimiter.test(symbol)) {
        current = symbol;
      }

      return { symbol: symbol, current: current, parts: parts };
    }
  }]);

  return Parser;
}();

Parser.digit = /[0-9]/;
Parser.letter = /[a-zA-Z]/;
Parser.delimiter = /\W/;
exports.default = Parser;