'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Types
 *
 * Supported units.
 *
 * @static
 * @internal
 */
var Types = function () {
  function Types() {
    _classCallCheck(this, Types);
  }

  _createClass(Types, null, [{
    key: 'validate',


    /**
     * Validate unit
     *
     * @param {string} symbol symbol to validate
     * @return {string} symbol validated symbol
     * @static
     */


    /**
     * MILLISECOND
     *
     * @param {string} MILLISECOND predefined millisecond
     * @static
     */


    /**
     * Minute
     *
     * @param {string} MINUTE predefined minute
     * @static
     */
    value: function validate(symbol) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = Object.keys(Types.aliases)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var key = _step.value;

          var array = Types.aliases[key];
          var length = array.length;

          for (var i = 0; i < length; ++i) {
            if (array[i] === symbol) {
              return key;
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return undefined;
    }

    /**
     * Gets greater unit
     *
     * @param {string} symbol symbol to use as a base
     * @return {string} symbol greater unit
     * @static
     */


    /**
     * Aliases
     *
     * @param {Object<Array<string>>} aliases unit aliases
     * @static
     */


    /**
     * SECOND
     *
     * @param {string} SECOND predefined second
     * @static
     */

    /**
     * Hour
     *
     * @param {string} HOUR predefined hour
     * @static
     */

  }, {
    key: 'greater',
    value: function greater(symbol) {
      if (symbol === Types.MINUTE) {
        return Types.HOUR;
      } else if (symbol === Types.SECOND) {
        return Types.MINUTE;
      } else if (symbol === Types.MILLISECOND) {
        return Types.SECOND;
      } else {
        return undefined;
      }
    }

    /**
     * Gets lesser unit
     *
     * @param {string} symbol symbol to use as a base
     * @return {string} symbol lesser unit
     * @static
     */

  }, {
    key: 'lesser',
    value: function lesser(symbol) {
      if (symbol === Types.HOUR) {
        return Types.MINUTE;
      } else if (symbol === Types.MINUTE) {
        return Types.SECOND;
      } else if (symbol === Types.SECOND) {
        return Types.MILLISECOND;
      } else {
        return undefined;
      }
    }
  }]);

  return Types;
}();

Types.HOUR = 'h';
Types.MINUTE = 'm';
Types.SECOND = 's';
Types.MILLISECOND = 'ms';
Types.aliases = {
  'h': ['h', 'ho', 'hour', 'hours'],
  'm': ['m', 'mi', 'min', 'minute', 'minutes'],
  's': ['s', 'se', 'sec', 'second', 'seconds'],
  'ms': ['ms', 'mil', 'milli', 'millisecond', 'milliseconds']
};
exports.default = Types;