(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.stringtoms = f()}})(function(){var define,module,exports;return (function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Pair = require('./Pair');

var _Pair2 = _interopRequireDefault(_Pair);

var _Types = require('../types/Types');

var _Types2 = _interopRequireDefault(_Types);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Analyzer
 *
 * Analyzes parsed array and generates pairs array
 *
 * @static
 * @internal
 */
var Analyzer = function () {
  function Analyzer() {
    _classCallCheck(this, Analyzer);
  }

  _createClass(Analyzer, null, [{
    key: 'analyze',


    /**
     * Analyze parsed array
     *
     * @param {Array<string>} array parsed array
     * @return {Array<Pair>} array analyzed array
     * @static
     */


    /**
     * Invalid value
     *
     * @param {int} MODE_VALUE value mode
     * @static
     */


    /**
     * letter
     *
     * @param {RegExp} leter regular expression for leter
     * @static
     */
    value: function analyze(array) {
      return Analyzer.complete(array);
    }

    /**
     * Complete parsed array
     *
     * Tries to complete left and right missing units or values
     *
     * @param {Array<string>} array parsed array
     * @return {Array<Pair>} array analyzed array
     * @static
     */


    /**
     * Invalid unit
     *
     * @param {int} MODE_UNIT unit mode
     * @static
     */


    /**
     * Invalid mode
     *
     * @param {int} MODE_INVALID invalid mode
     * @static
     */

    /**
     * digit
     *
     * @param {RegExp} digit regular expression for digit
     * @static
     */

  }, {
    key: 'complete',
    value: function complete(array) {
      var modified = Analyzer.normalize(array);

      var skipped = false;
      for (var i = 0; i < modified.length; ++i) {
        var pair = modified[i];
        if (pair.unit && skipped) {
          skipped = false;

          for (var j = i - 1; j >= 0; --j) {
            var leftPair = modified[j];
            var rightPair = modified[j + 1];
            if (!leftPair.unit) {
              leftPair.unit = _Types2.default.greater(rightPair.unit);
              if (!leftPair.unit) {
                modified.splice(j, 1);
                --i;
              }
            } else {
              break;
            }
          }
        } else if (!pair.unit) {
          if (i > 0) {
            var _leftPair = modified[i - 1];
            if (_leftPair.unit) {
              var lesser = _Types2.default.lesser(_leftPair.unit);
              if (lesser) {
                pair.unit = lesser;
              } else {
                skipped = true;
              }
            } else {
              skipped = true;
            }
          } else {
            skipped = true;
          }
        }
      }

      while (modified.length > 0 && !modified[modified.length - 1].unit) {
        modified.splice(modified.length - 1, 1);
      }

      return modified;
    }

    /**
     * Normalizes parsed array
     *
     * Removes missing or invalid value unit couples
     *
     * @param {Array<string>} array parsed array
     * @return {Array<Pair>} array analyzed array
     * @static
     */

  }, {
    key: 'normalize',
    value: function normalize(array) {
      var modified = Analyzer.group(array);

      for (var i = 0; i < modified.length; ++i) {
        var pair = modified[i];
        if (pair.unit) {
          var validated = _Types2.default.validate(pair.unit);
          if (validated !== undefined) {
            pair.unit = validated;
          } else {
            modified.splice(i, 1);
            --i;
          }
        }
      }

      return modified;
    }

    /**
     * Groups parsed array
     *
     * Groups value units into pairs
     *
     * @param {Array<string>} array parsed array
     * @return {Array<Pair>} array analyzed array
     * @static
     */

  }, {
    key: 'group',
    value: function group(array) {
      var length = array.length;

      var parts = [];
      var i = void 0;
      var symbol = void 0;
      var current = void 0;
      var mode = void 0;

      for (i = 0; i < length; ++i) {
        symbol = array[i];

        if (current === undefined) {
          current = new _Pair2.default();
        }

        if (Analyzer.digit.test(symbol)) {
          mode = Analyzer.MODE_VALUE;
        } else if (Analyzer.letter.test(symbol)) {
          mode = Analyzer.MODE_UNIT;
        } else {
          mode = Analyzer.MODE_INVALID;
        }

        if (mode === Analyzer.MODE_INVALID) {
          //
        } else if (mode === Analyzer.MODE_VALUE) {
          if (current.value === undefined) {
            current.value = parseInt(symbol);
          } else {
            parts.push(current);
            current = new _Pair2.default(parseInt(symbol));
          }
        } else if (mode === Analyzer.MODE_UNIT) {
          current.unit = symbol;

          if (current.value === undefined) {
            current.value = 1;
          }
        }

        if (current.unit !== undefined) {
          parts.push(current);
          current = undefined;
        }
      }

      if (current !== undefined) {
        parts.push(current);
        current = undefined;
      }

      return parts;
    }
  }]);

  return Analyzer;
}();

Analyzer.digit = /[0-9]+/;
Analyzer.letter = /[a-zA-Z]+/;
Analyzer.MODE_INVALID = 0;
Analyzer.MODE_VALUE = 1;
Analyzer.MODE_UNIT = 2;
exports.default = Analyzer;
},{"../types/Types":7,"./Pair":2}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Pair
 *
 * Collection of value and unit
 *
 * @param {int} value value of the pair
 * @param {string} unit unit of the pair
 *
 * @internal
 */
var Pair =
/**
 * Pair constructor
 *
 * @param {int} value value of the pair
 * @param {string} unit unit of the pair
 */
function Pair(value, unit) {
  _classCallCheck(this, Pair);

  this.value = value;
  this.unit = unit;
};

exports.default = Pair;
},{}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Types = require('../types/Types');

var _Types2 = _interopRequireDefault(_Types);

var _Pair = require('../analyzer/Pair');

var _Pair2 = _interopRequireDefault(_Pair);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Converter
 *
 * Converts analyzed array to int
 *
 * @static
 * @internal
 */
var Converter = function () {
  function Converter() {
    _classCallCheck(this, Converter);
  }

  _createClass(Converter, null, [{
    key: 'toMilliseconds',

    /**
     * Converts analyzed array to milliseconds
     *
     * @param {Array<Pair>} array analyzed array
     * @return {int} millisedonds milliseconds
     * @static
     */
    value: function toMilliseconds(array) {
      var sum = 0;
      var pair = void 0;
      var i = void 0;
      var length = array.length;

      for (i = 0; i < length; ++i) {
        pair = array[i];
        if (pair.unit === _Types2.default.MILLISECOND) {
          sum += pair.value;
        } else if (pair.unit === _Types2.default.SECOND) {
          sum += pair.value * 1000;
        } else if (pair.unit === _Types2.default.MINUTE) {
          sum += pair.value * 1000 * 60;
        } else if (pair.unit === _Types2.default.HOUR) {
          sum += pair.value * 1000 * 60 * 60;
        }
      }

      return sum;
    }
  }]);

  return Converter;
}();

exports.default = Converter;
},{"../analyzer/Pair":2,"../types/Types":7}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Parser = require('../parser/Parser');

var _Parser2 = _interopRequireDefault(_Parser);

var _Analyzer = require('../analyzer/Analyzer');

var _Analyzer2 = _interopRequireDefault(_Analyzer);

var _Converter = require('./Converter');

var _Converter2 = _interopRequireDefault(_Converter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Converts analyzed string to milliseconds
 *
 * @param {string} string string to analyze
 * @return {int} millisedonds milliseconds
 */
function toms(string) {
  return _Converter2.default.toMilliseconds(_Analyzer2.default.analyze(_Parser2.default.split(string)));
}

exports.default = toms;
},{"../analyzer/Analyzer":1,"../parser/Parser":6,"./Converter":3}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.stringtoms = exports.toms = exports.Types = exports.Pair = exports.Analyzer = exports.Parser = undefined;

var _Parser = require('./parser/Parser');

var _Parser2 = _interopRequireDefault(_Parser);

var _Analyzer = require('./analyzer/Analyzer');

var _Analyzer2 = _interopRequireDefault(_Analyzer);

var _Pair = require('./analyzer/Pair');

var _Pair2 = _interopRequireDefault(_Pair);

var _Types = require('./types/Types');

var _Types2 = _interopRequireDefault(_Types);

var _toms = require('./converters/toms');

var _toms2 = _interopRequireDefault(_toms);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.Parser = _Parser2.default;
exports.Analyzer = _Analyzer2.default;
exports.Pair = _Pair2.default;
exports.Types = _Types2.default;
exports.toms = _toms2.default;
exports.stringtoms = _toms2.default;
},{"./analyzer/Analyzer":1,"./analyzer/Pair":2,"./converters/toms":4,"./parser/Parser":6,"./types/Types":7}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Parser
 *
 * Parses string into array of meaningful values.
 * Usually it's value, unit, value, unit, but might be
 * only value, value or unit, unit or completely mixed
 *
 * @static
 * @internal
 */
var Parser = function () {
  function Parser() {
    _classCallCheck(this, Parser);
  }

  _createClass(Parser, null, [{
    key: 'split',


    /**
     * Split string into parts
     *
     * @param {string} string string to split
     * @return {Array<string>} array value unit parts
     * @static
     */


    /**
     * letter
     *
     * @param {RegExp} leter regular expression for leter
     * @static
     */
    value: function split(string) {
      var length = string.length;

      var parts = [];
      var i = void 0;
      var current = '';
      var symbol = void 0;
      var pushed = void 0;

      for (i = 0; i < length; ++i) {
        symbol = string[i];

        if (Parser.delimiter.test(symbol)) {
          pushed = Parser._push(symbol, current, parts);
          symbol = pushed.symbol;current = pushed.current;parts = pushed.parts;
        } else if (current !== '') {
          if (Parser.digit.test(current[0]) && Parser.digit.test(symbol) || Parser.letter.test(current[0]) && Parser.letter.test(symbol)) {
            current += symbol;
          } else {
            pushed = Parser._push(symbol, current, parts);
            symbol = pushed.symbol;current = pushed.current;parts = pushed.parts;
          }
        } else {
          current += symbol;
        }
      }

      pushed = Parser._push(symbol, current, parts);
      symbol = pushed.symbol;current = pushed.current;parts = pushed.parts;

      return parts;
    }

    /**
     * Pushes current symbol to the parts
     *
     * @param {string} symbol current symbol
     * @param {string} current current part item
     * @param {Array<string>} parts parts of value units
     * @return {Object} object all the parameters
     * @static
     * @private
     */


    /**
     * delimiter
     *
     * @param {RegExp} delimiter regular expression for delimiter
     * @static
     */

    /**
     * digit
     *
     * @param {RegExp} digit regular expression for digit
     * @static
     */

  }, {
    key: '_push',
    value: function _push(symbol, current, parts) {
      if (current !== '') {
        parts.push(current);
        current = '';
      }
      if (symbol && !Parser.delimiter.test(symbol)) {
        current = symbol;
      }

      return { symbol: symbol, current: current, parts: parts };
    }
  }]);

  return Parser;
}();

Parser.digit = /[0-9]/;
Parser.letter = /[a-zA-Z]/;
Parser.delimiter = /\W/;
exports.default = Parser;
},{}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Types
 *
 * Supported units.
 *
 * @static
 * @internal
 */
var Types = function () {
  function Types() {
    _classCallCheck(this, Types);
  }

  _createClass(Types, null, [{
    key: 'validate',


    /**
     * Validate unit
     *
     * @param {string} symbol symbol to validate
     * @return {string} symbol validated symbol
     * @static
     */


    /**
     * MILLISECOND
     *
     * @param {string} MILLISECOND predefined millisecond
     * @static
     */


    /**
     * Minute
     *
     * @param {string} MINUTE predefined minute
     * @static
     */
    value: function validate(symbol) {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = Object.keys(Types.aliases)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var key = _step.value;

          var array = Types.aliases[key];
          var length = array.length;

          for (var i = 0; i < length; ++i) {
            if (array[i] === symbol) {
              return key;
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return undefined;
    }

    /**
     * Gets greater unit
     *
     * @param {string} symbol symbol to use as a base
     * @return {string} symbol greater unit
     * @static
     */


    /**
     * Aliases
     *
     * @param {Object<Array<string>>} aliases unit aliases
     * @static
     */


    /**
     * SECOND
     *
     * @param {string} SECOND predefined second
     * @static
     */

    /**
     * Hour
     *
     * @param {string} HOUR predefined hour
     * @static
     */

  }, {
    key: 'greater',
    value: function greater(symbol) {
      if (symbol === Types.MINUTE) {
        return Types.HOUR;
      } else if (symbol === Types.SECOND) {
        return Types.MINUTE;
      } else if (symbol === Types.MILLISECOND) {
        return Types.SECOND;
      } else {
        return undefined;
      }
    }

    /**
     * Gets lesser unit
     *
     * @param {string} symbol symbol to use as a base
     * @return {string} symbol lesser unit
     * @static
     */

  }, {
    key: 'lesser',
    value: function lesser(symbol) {
      if (symbol === Types.HOUR) {
        return Types.MINUTE;
      } else if (symbol === Types.MINUTE) {
        return Types.SECOND;
      } else if (symbol === Types.SECOND) {
        return Types.MILLISECOND;
      } else {
        return undefined;
      }
    }
  }]);

  return Types;
}();

Types.HOUR = 'h';
Types.MINUTE = 'm';
Types.SECOND = 's';
Types.MILLISECOND = 'ms';
Types.aliases = {
  'h': ['h', 'ho', 'hour', 'hours'],
  'm': ['m', 'mi', 'min', 'minute', 'minutes'],
  's': ['s', 'se', 'sec', 'second', 'seconds'],
  'ms': ['ms', 'mil', 'milli', 'millisecond', 'milliseconds']
};
exports.default = Types;
},{}]},{},[5])(5)
});